unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FileCtrl;

type
  TForm1 = class(TForm)
	PaintBox: TPaintBox;
	Button1: TButton;
	ComboBox1: TComboBox;
	Label1: TLabel;
	Label2: TLabel;
	Label3: TLabel;
	Memo1: TMemo;
	CheckBox1: TCheckBox;
	procedure FormCreate(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure Button1Click(Sender: TObject);
	procedure ComboBox1Change(Sender: TObject);
	procedure FormPaint(Sender: TObject);
	procedure CheckBox1Click(Sender: TObject);

  private

  public

  end;

var
	Form1 : TForm1;

implementation

{$R *.DFM}

uses
	WinHan;

var
	Hangul : THangul;

procedure PutPixel(x, y : Integer; Color : Longint);
begin
	Form1.PaintBox.Canvas.Pixels[x,y] := Color;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   SearchRec : TSearchRec;
   Found     : Integer;
begin
   Hangul := THangul.CreateEx(PutPixel, nil, nil);

   Found := FindFirst( ExtractFilePath( Application.ExeName ) + '*.fnt', faAnyFile, SearchRec );
   while Found = 0 do begin
      ComboBox1.Items.Add( SearchRec.Name );
      Found := FindNext( SearchRec );
   end;
   FindClose( SearchRec );

   if ComboBox1.Items.Count > 0 then begin
      ComboBox1.ItemIndex := 0;
      Hangul.Initialize( nil, PChar( ComboBox1.Items[0] ) );
   end
   else begin
      ComboBox1.Text := 'N/A';
   end;

   CheckBox1Click( Self );
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   Hangul.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   i : Integer;
begin
   PaintBox.Canvas.FillRect( PaintBox.ClientRect );
   for i := 0 to Pred( Memo1.Lines.Count ) do begin
      if CheckBox1.Checked then
         Hangul.PrintHangul( 0, 20*i, Memo1.Lines[i], RGB( 255, 16, 64 ), FALSE)
      else
         Hangul.PrintHangul( 0, 20*i, Memo1.Lines[i], clBlack, FALSE)
   end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
   if ComboBox1.Items.Count > 0 then begin
      Hangul.Initialize( nil, PChar( ComboBox1.Items[ComboBox1.ItemIndex] ) );
   end
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   PaintBox.Canvas.Brush.Color := clWhite;
   PaintBox.Canvas.Brush.Style := bsSolid;
   PaintBox.Canvas.FillRect( PaintBox.ClientRect );
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
   if CheckBox1.Checked then begin
      Hangul.HangulUnit := huGradation;
   end
   else begin
      Hangul.HangulUnit := huPixel;
   end;
end;

end.

